import 'dart:convert';

import 'package:http/http.dart';
import 'package:test_sa/providers/loading_list_notifier.dart';

import '../../controllers/api_routes/api_manager.dart';
import '../../controllers/api_routes/urls.dart';
import '../../models/lookup.dart';

class LoanAvailabilityProvider extends LoadingListNotifier<Lookup> {
  @override
  Future getDate() async {
    if (loading == true) return -2;

    loading = true;
    notifyListeners();
    try {
      Response response = await ApiManager.instance.get(URLs.getServiceLoanAvailability);
      stateCode = response.statusCode;
      if (response.statusCode >= 200 && response.statusCode < 300) {
        // client's request was successfully received
        List categoriesListJson = json.decode(response.body)["data"];
        items = categoriesListJson.map((item) => Lookup.fromJson(item)).toList();
      }
      loading = false;
      notifyListeners();
      return response.statusCode;
    } catch (error) {
      loading = false;
      stateCode = -1;
      notifyListeners();
      return -1;
    }
  }
}
